import 'dart:convert';

import 'package:eggnstone_amazon_chime/eggnstone_amazon_chime.dart';
import 'package:http/http.dart' as http;

class MeetingSessionCreator
{
    String _externalMeetingId = 'Test';
    String _externalUserId = 'Host';

    Future<String?> create()
    async
    {
        String authority = 'europe-west3-videobesuch-dev-eur3.cloudfunctions.net';
        String unencodedPath = '/chime_public_api';
        Uri uri = Uri.https(authority, unencodedPath);

        Map<String, String> params =
        {
            'ApiKey': 'VMjNDlGuTtvmSWpeVsSpBaHMaGueTFfzb8l2illwneNmIElYzwNFx025CMjvpZaKFou6i1vVybtt2td8j5dyLK70Xros4LqF6Rz',
            'Command': 'CreateMeeting',
            'ExternalMeetingId': _externalMeetingId
        };

        http.Response response = await http.post(uri, body: params);
        if (response.statusCode != 200)
            return 'FAIL';

        dynamic decodedResponse = jsonDecode(response.body);
        String meetingId = decodedResponse['MeetingId'];
        dynamic mediaPlacement = decodedResponse['MediaPlacement'];
        String mediaPlacementAudioHostUrl = mediaPlacement['AudioHostUrl'];
        String mediaPlacementAudioFallbackUrl = mediaPlacement['AudioFallbackUrl'];
        String mediaPlacementSignalingUrl = mediaPlacement['SignalingUrl'];
        String mediaPlacementTurnControlUrl = mediaPlacement['TurnControlUrl'];

        params =
        {
            'ApiKey': 'VMjNDlGuTtvmSWpeVsSpBaHMaGueTFfzb8l2illwneNmIElYzwNFx025CMjvpZaKFou6i1vVybtt2td8j5dyLK70Xros4LqF6Rz',
            'Command': 'CreateAttendee',
            'ExternalMeetingId': _externalMeetingId,
            'ExternalUserId': _externalUserId
        };

        response = await http.post(uri, body: params);
        if (response.statusCode != 200)
            return 'FAIL';

        decodedResponse = jsonDecode(response.body);
        String attendeeId = decodedResponse['AttendeeId'];
        String joinToken = decodedResponse['JoinToken'];

        return Chime.createMeetingSession(
            meetingId: meetingId,
            externalMeetingId: _externalMeetingId,
            mediaRegion: 'eu-central-1',
            mediaPlacementAudioHostUrl: mediaPlacementAudioHostUrl,
            mediaPlacementAudioFallbackUrl: mediaPlacementAudioFallbackUrl,
            mediaPlacementSignalingUrl: mediaPlacementSignalingUrl,
            mediaPlacementTurnControlUrl: mediaPlacementTurnControlUrl,
            attendeeId: attendeeId,
            externalUserId: _externalUserId,
            joinToken: joinToken
        );
    }
}
